DECLARE SUB MAKHUF ()

DECLARE SUB HUFFDECOMPRESS (INNAME AS STRING, OUTNAME AS STRING)
TYPE NODE
        BIT0 AS INTEGER
        BIT1 AS INTEGER
END TYPE

DIM SHARED huffq AS STRING
DIM SHARED u0 AS STRING
DIM SHARED w0 AS STRING
DIM SHARED x0 AS STRING
DIM SHARED x1 AS STRING * 1
DIM SHARED x2 AS STRING * 2
DIM SHARED x4 AS STRING * 4
DIM SHARED x8 AS STRING * 8
DIM SHARED y0 AS STRING
DIM SHARED y1 AS STRING * 1
DIM SHARED y2 AS STRING * 2
DIM SHARED y4 AS STRING * 4
DIM SHARED y8 AS STRING * 8
DIM SHARED z0 AS STRING * 1028
DIM SHARED z4 AS STRING * 4
DIM SHARED NODES(0 TO 254) AS NODE
z4 = "!ID!"

if COMMAND$ <> "" then goto 50

OPEN "MAPTHEAD.CK7" FOR BINARY AS #2
IF LOF(2) > 0 THEN
 GOTO 100
END IF
CLOSE


'___________________________________________________
' Get map huff tree for dump
'___________________________________________________
OPEN "KDREAMS.MAP" FOR BINARY AS #3
OPEN "KDREAMS.EXE" FOR BINARY AS #2
SEEK #2, &H2B847
FOR I = 0 TO 254
 GET #2, , NODES(I).BIT0
 GET #2, , NODES(I).BIT1
NEXT I

' Extract maphead as mapthead for COMPRESSED maps
OPEN "MAPTHEAD.CK7" FOR OUTPUT AS #4
PRINT #4, MKI$(7); MKI$(2); STRING$(288, 0); MKI$(-21555);
x0 = SPACE$(400)
y0 = ""
GET #2, 136787, x0
FOR l1 = 0 TO 99
IF CVL(MID$(x0, (l1 * 4) + 1, 4)) = 0 THEN
 PRINT #4, MKL$(-1);
 y0 = y0 + MKL$(0)
ELSE
 PRINT #4, MID$(x0, (l1 * 4) + 1, 4);
 y0 = y0 + MKL$(38)
END IF
NEXT l1
PRINT #4, y0; MKI$(5);
CLOSE #4
OPEN "MAPTHEAD.CK7" FOR BINARY AS #4


'Extract compressed level headers to maps file
OPEN "MAPS.CK7" FOR OUTPUT AS #1
PRINT #1, "TED5v1.0";
FOR l1 = 0 TO 99
GET #2, 137187 + l1, x1
GET #2, 136787 + (l1 * 4), x4
IF ASC(x1) > 0 THEN
 y4 = MKL$(LOF(1))
 PUT #4, (l1 * 4) + 295, y4
 x0 = SPACE$(ASC(x1))
 GET #3, CVL(x4) + 1, x0
 OPEN "TEMP.000" FOR OUTPUT AS #6
 PRINT #6, "HUFF" + MKL$(38) + x0;
 CLOSE #6
 HUFFDECOMPRESS "TEMP.000", "TEMP.BEH"
 OPEN "TEMP.BEH" FOR BINARY AS #6
 x0 = SPACE$(38)
 GET #6, 1, x0
 CLOSE #6
 KILL "TEMP.BEH"
 PRINT #1, x0;
END IF
NEXT l1
CLOSE #1

OPEN "MAPS.CK7" FOR BINARY AS #7
OPEN "MAPTEMP.CK7" FOR OUTPUT AS #1
x0 = SPACE$(692)
PRINT #1, x0;

' Decompress level plane data to RLEW
x = -1
FOR l1 = 0 TO 99
GET #2, 137187 + l1, x1
IF ASC(x1) > 0 THEN
 PRINT "Decompressing level"; l1; "..."
 x = x + 1
 FOR l2 = 0 TO 2
  GET #7, (x * 38) + (l2 * 4) + 9, x4
  y4 = MKL$(LOF(1))
  PUT #7, (x * 38) + (l2 * 4) + 9, y4
  GET #7, (x * 38) + (l2 * 2) + 21, x2
  x0 = SPACE$(CVI(x2) - 2)
  GET #3, CVL(x4) + 1, x2
  GET #3, CVL(x4) + 3, x0
  PUT #7, (x * 38) + (l2 * 2) + 21, x2
  OPEN "TEMP.000" FOR OUTPUT AS #6
  PRINT #6, "HUFF" + x2 + MKI$(0) + x0;
  CLOSE #6
  HUFFDECOMPRESS "TEMP.000", "TEMP.BEH"
  OPEN "TEMP.BEH" FOR BINARY AS #6
  FOR l3 = 1 TO LOF(6) \ 2
  GET #6, (l3 * 2) - 1, x2
  PRINT #1, x2;
  NEXT l3
  CLOSE #6
  KILL "TEMP.BEH"
 NEXT l2
PRINT #1, z4;
END IF
NEXT l1

' Now add the dec level headers to the map file
CLOSE #1
OPEN "MAPTEMP.CK7" FOR BINARY AS #1
x0 = SPACE$(692)
GET #7, 1, x0
PUT #1, 1, x0
CLOSE
KILL "TEMP.000"
KILL "MAPS.CK7"

' Move off levels to extract EGA stuff:
OPEN "KDREAMS.EXE" FOR BINARY AS #2
OPEN "EGADICT.CK7" FOR OUTPUT AS #5
x0 = SPACE$(1024)
GET #2, 177223, x0
PRINT #5, x0;
CLOSE #5
OPEN "EGAHEAD.CK7" FOR OUTPUT AS #5
x0 = SPACE$(12060)
GET #2, 124705, x0
FOR l1 = 0 TO 3014
PRINT #5, MID$(x0, (l1 * 4) + 1, 3);
NEXT l1
CLOSE #5

'Finally set up TED5
OPEN "GFXINFOE.CK7" FOR BINARY AS #5
x2 = MKI$(1440)
PUT #5, 5, x2
x2 = MKI$(1206)
PUT #5, 7, x2
x2 = MKI$(370)
PUT #5, 17, x2
x2 = MKI$(1810)
PUT #5, 19, x2
x1 = CHR$(0)
PUT #5, 46, x1
CLOSE
END


'___________________________________________________
50 ' Create a new EGAHEAD
'___________________________________________________
OPEN COMMAND$ FOR BINARY AS #1
IF LOF(1) = 12060 THEN
 x0 = SPACE$(12060)
 GET #1, 1, x0
 CLOSE #1
 OPEN "EGAHEAD.CK7" FOR OUTPUT AS #1
 FOR l1 = 0 TO 3014
 PRINT #1, MID$(x0, (l1 * 4) + 1, 3);
 NEXT l1
 CLOSE #1
END IF
END

'___________________________________________________
100 ' Convert levels between formats
'___________________________________________________
OPEN "KDREAMS.MAP" FOR OUTPUT AS #1
CLOSE #1
OPEN "KDREAMS.MAP" FOR BINARY AS #1
OPEN "MAPHEAD.CK7" FOR OUTPUT AS #3
OPEN "MAPTEMP.CK7" FOR BINARY AS #7
x0 = "TED5v1.0"
PUT #1, 1, x0
PRINT #3, MKI$(-21555);

' Modify the level planes and compile gamemaps file
FOR l1 = 0 TO 99
GET #2, 295 + (l1 * 4), x4
x = CVL(x4) + 1
IF x > 1 THEN
 PRINT "Converting level"; l1; "..."
 w0 = w0 + CHR$(38)
 u0 = ""
 y0 = ""
 FOR l2 = 0 TO 2
  GET #7, x + (l2 * 4), x4
  GET #7, x + (l2 * 2) + 12, x2
  x0 = SPACE$(CVI(x2))
  GET #7, CVL(x4) + 1, x0
  y0 = y0 + MKL$(LOF(1))
  u0 = u0 + MKI$(CVI(x2) + 2)
  PUT #1, LOF(1) + 1, x2
  PUT #1, LOF(1) + 1, x0
 NEXT l2
 PRINT #3, MKL$(LOF(1));
 PUT #1, LOF(1) + 1, y0
 PUT #1, LOF(1) + 1, u0
 x0 = SPACE$(20)
 GET #7, x + 18, x0
 PUT #1, LOF(1) + 1, x0
ELSE
 PRINT #3, MKL$(0);
 w0 = w0 + CHR$(0)
END IF
NEXT l1
PRINT #3, w0;
CLOSE

MAKHUF
OPEN "MAPDICT.CK7" FOR OUTPUT AS #1
PRINT #1, huffq
CLOSE
END

'___________________________________________________
SUB HUFFDECOMPRESS (INNAME AS STRING, OUTNAME AS STRING) ' by Napalm
'___________________________________________________
        DIM INFILE AS INTEGER, OUTFILE AS INTEGER, I AS INTEGER
        DIM SIG AS LONG, OUTLEN AS LONG, BITMASK AS INTEGER
        DIM CURNODE AS INTEGER, NEXTNODE AS INTEGER
        DIM CHRIN AS STRING * 1, CHROUT AS STRING * 1

        ' Open input file
        INFILE = FREEFILE
        OPEN INNAME FOR BINARY ACCESS READ AS INFILE
       
        ' Check file signature
        GET INFILE, , SIG
        IF SIG <> &H46465548 THEN ' Hex for: HUFF in little endian
                PRINT "INVALID FILE!"
                EXIT SUB
        END IF
       
        ' Get output length
        OUTLEN = 0
        GET INFILE, , OUTLEN


        ' Open output file
        OUTFILE = FREEFILE
        OPEN OUTNAME FOR BINARY ACCESS WRITE AS OUTFILE

        ' Decompress input data using binary tree
        CURNODE = 254
        DO
                BITMASK = 0
                GET INFILE, , CHRIN
                DO
                        ' Decide which node to travel down depending on
                        '   input bits from CHRIN.
                        IF ASC(CHRIN) AND 2 ^ BITMASK THEN
                                NEXTNODE = NODES(CURNODE).BIT1
                        ELSE
                                NEXTNODE = NODES(CURNODE).BIT0
                        END IF
                       
                        ' Is this next node another part of the tree or
                        '   is it a end node? Less than 256 mean end node.
                        IF NEXTNODE < 256 THEN
                               
                                ' Get output char from end node and save.
                                CHROUT = CHR$(NEXTNODE AND &HFF)
                                PUT OUTFILE, , CHROUT
                               
                                ' Amend output length and start from top of
                                '   binary tree.
                                OUTLEN = OUTLEN - 1
                                CURNODE = 254

                        ELSE
                                ' Travel to next node
                                CURNODE = (NEXTNODE AND &HFF)

                        END IF

                        ' Move to next input bit
                        BITMASK = BITMASK + 1
                LOOP WHILE BITMASK < 8 AND OUTLEN > 0
                ' Loop while we still need to output data
        LOOP WHILE OUTLEN > 0

        ' Clean up
        CLOSE OUTFILE
        CLOSE INFILE

END SUB

'___________________________________________________
SUB MAKHUF 'Make a degenerate huffman tree, store as huffq
'___________________________________________________
FOR t = 0 TO 255
huff = ((FIX(t MOD 2)) * 128) + ((FIX((t MOD 4) / 2)) * 64) + ((FIX((t MOD 8) / 4)) * 32) + (16 * (FIX((t MOD 16) / 8)))
huff = huff + (8 * (FIX((t MOD 32) / 16))) + (4 * (FIX((t MOD 64) / 32))) + (2 * (FIX((t MOD 128) / 64))) + (FIX(t / 128))
huffq = huffq + MKI$(huff)
NEXT t
FOR t = 0 TO 253
huffq = huffq + MKI$(t + 256)
NEXT t
END SUB

